#include <stdio.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
// 27.10.2008 okaegi create one file (size 64K) based on input (bally, stern)

static   unsigned char buf[66001];
static   unsigned char buf1[5000];  
static   unsigned char buf2[5000];  

main(int argc,char *argv[])
{	
  int fin,fout,n1,n2,off;
  char fileout[60];
  const	char u1716[] = "u1.716";
  const	char u2716[] = "u2.716";
  const	char u5716[] = "u5.716";
  const	char u6716[] = "u6.716";      
  const	char u2732[] = "u2.732";
  const char u6732[] = "u6.732";  
  if (argc != 4) {
	printf("romadd type(u2.732,u6.732,u1.716,u2.716,u5.716,u6.716) inputfile outputfile \n");
	return -1;
  }
// ; adr 1800 - 1fff U6
// ; adr 5800-  58ff u6
// ; adr 1000 - 17ff u2
// ; adr 5000 - 57ff u2
  printf("romadd:create one large 64k rom (%s) for early bally / stern pinball eproms add %s\n", argv[3],argv[2]);  
  printf("by okaegi v1.01 \n");    	
  memset(buf,0x00,66000);
  sprintf(fileout,"%s",argv[3]);
  fout = open(fileout,O_RDONLY|O_BINARY);
  if (fout == -1) {
  	printf("cant open %s, we will create it...\n", fileout);  
        fout = creat(fileout,666);
 	if (fout == -1) {
      		printf("romadd:(1) cant open %s as output\n", fileout);  
         	return -1;
 	}
  	close(fout);
  	fout = open(fileout,O_WRONLY|O_TRUNC|O_BINARY);
  	if (fout == -1) {
      		printf("romadd:(2) cant open %s as output\n", fileout);  
      		return -1;
  	}
  	write(fout,buf,0x10000);
  	close(fout);
   	fout = open(fileout,O_RDONLY|O_BINARY);
  	if (fout == -1) {
  		printf(" cant open %s\n", fileout);  
		return -1;
	}
  }
  read(fout,buf,0x10000);	
  close(fout);
  fin = open(argv[2],O_RDONLY|O_BINARY);
  if (fin == -1) {
  	printf(" cant open %s\n", argv[2]);  
  	return -1;
  }
  n1 = read (fin,buf1,0x800);
  n2 = read (fin,buf2,0x800);  
  close(fin);
  if (strncmp(argv[1],u1716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x1000],&buf1[0],0x800);
   }
  if (strncmp(argv[1],u5716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x1800],&buf1[0],0x800);
   }
  if (strncmp(argv[1],u2716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x5000],&buf1[0],0x800);
   }
  if (strncmp(argv[1],u6716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x5800],&buf1[0],0x800);
	if (n1 = 0x800) memcpy(&buf[0xfff8],&buf1[0x7f8],0x8);
   }
  if (strncmp(argv[1],u2732,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x1000],&buf1[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0x5000],&buf2[0],0x800);
   }
  if (strncmp(argv[1],u6732,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x1800],&buf1[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0x5800],&buf2[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0xfff8],&buf2[0x7f8],0x8);
   }
  fout = open(fileout,O_WRONLY|O_TRUNC|O_BINARY);
  if (fout == -1) {
      printf("calcbal:(3) cant open %s as output\n", fileout);  
      return -1;
  }
  write(fout,buf,0x10000);
  close(fout);
  printf("calcbal:  %s writen \n", fileout);    
}
