#include <stdio.h>
#include <stdarg.h>
#include <fcntl.h>
#include <string.h>
// 27.10.2008 okaegi create one file (size 64K) based on input
static   unsigned char buf[66001];
static   unsigned char buf1[5000];  
static   unsigned char buf2[5000];  

main(int argc,char *argv[])
{	
  int fin,fout,n1,n2,off;
  char fileout[60];
  const	char u60716[] = "60.716";
  const	char u68716[] = "68.716";
  const	char u70716[] = "70.716";
  const	char u78716[] = "78.716";      
  const	char u58716[] = "58.716";      
  const	char u60732[] = "60.732";
  const char u70732[] = "70.732";  
  const char uD0732[] = "D0.732";  
  const char uE0732[] = "E0.732";  

  if (argc != 4) {
	printf("romadds6: type(70.732,60.732,60.716,68.716,70.716,76.716,58.716,D0.732,E0.732) inputfile outputfile \n");
	return -1;
  }
  printf("romadds6:create one large 64k rom (%s) for system 6 williams pinball eproms add %s\n", argv[3],argv[2]);  
  printf("by okaegi v1.03 \n");    	
  memset(buf,0x00,66000);
  sprintf(fileout,"%s",argv[3]);
  fout = open(fileout,O_RDONLY|O_BINARY);
  if (fout == -1) {
  	printf("cant open %s, we will create it...\n", fileout);  
        fout = creat(fileout,666);
 	if (fout == -1) {
      		printf("romadds6:(1) cant open %s as output\n", fileout);  
         	return -1;
 	}
  	close(fout);
  	fout = open(fileout,O_WRONLY|O_TRUNC|O_BINARY);
  	if (fout == -1) {
      		printf("romadds6:(2) cant open %s as output\n", fileout);  
      		return -1;
  	}
  	write(fout,buf,0x10000);
  	close(fout);
   	fout = open(fileout,O_RDONLY|O_BINARY);
  	if (fout == -1) {
  		printf("romadds6: cant open %s\n", fileout);  
		return -1;
	}
  }
  read(fout,buf,0x10000);	
  close(fout);
  fin = open(argv[2],O_RDONLY|O_BINARY);
  if (fin == -1) {
  	printf("romadds6: cant open %s\n", argv[2]);  
  	return -1;
  }
  n1 = read (fin,buf1,0x800);
  n2 = read (fin,buf2,0x800);  
  close(fin);




  if (strncmp(argv[1],u60716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x6000],&buf1[0],0x800);
   }
  if (strncmp(argv[1],u68716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x6800],&buf1[0],0x800);
   }
  if (strncmp(argv[1],u58716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x5800],&buf1[0],0x800);
   }

  if (strncmp(argv[1],u70716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x7000],&buf1[0],0x800);
   }
  if (strncmp(argv[1],u78716,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x7800],&buf1[0],0x800);
	if (n1 = 0x800) memcpy(&buf[0xfff8],&buf1[0x7f8],0x8);
   }
  if (strncmp(argv[1],u60732,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x6000],&buf1[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0x6800],&buf2[0],0x800);
   }
  if (strncmp(argv[1],uD0732,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0xD000],&buf1[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0xD800],&buf2[0],0x800);
   }
  if (strncmp(argv[1],uE0732,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0xE000],&buf1[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0xE800],&buf2[0],0x800);
   }


  if (strncmp(argv[1],u70732,6) == 0) { 	
	if (n1 = 0x800) memcpy(&buf[0x7000],&buf1[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0x7800],&buf2[0],0x800);
	if (n2 = 0x800) memcpy(&buf[0xfff8],&buf2[0x7f8],0x8);
   }
  fout = open(fileout,O_WRONLY|O_TRUNC|O_BINARY);
  if (fout == -1) {
      printf("romadds6:(3) cant open %s as output\n", fileout);  
      return -1;
  }
  write(fout,buf,0x10000);
  close(fout);
  printf("romadds6:  %s writen \n", fileout);    
}
